> For the complete documentation index, see [llms.txt](https://docs.raga.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.raga.ai/ragaai-catalyst/ragaai-metric-library/additional-metrics/evaluation/coherence.md).

# Coherence

**Objective**: The test is intended to check the coherence of the model response i.e if the model is able to generate ideas and arguments in a logical manner

**Parameters:**

`data:`

* `prompt` (str): The prompt for the response.
* `response` (str): The response to be evaluated.
* `context` (str, optional): The context for the response (default is None).

`arguments:`

* `strictness` (int, optional): The number of times response is evaluated (default is 1).
* `model` (str, optional): The model to be used for evaluation (default is "gpt-4").

**Interpretation**: Passed result signifies model is more coherent in its response to the given prompt. Failed result signifies model is less coherent in its response, giving unorganized or incorrect response.

```python
# Add tests with custom data
evaluator.add_test(
    test_names=["coherence_test"],
    data={
        "prompt": ["Can you explain the process of photosynthesis in detail?"],
        "response": ["Photosynthesis is a complex biochemical process in which plants convert light energy into chemical energy, utilizing water, carbon dioxide, chlorophyll, and enzymes."]
    },
    arguments={"model": "gpt-4", "threshold": 0.6},
).run()

evaluator.print_results()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.raga.ai/ragaai-catalyst/ragaai-metric-library/additional-metrics/evaluation/coherence.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
